// Copyright 1996, Marimba Inc. All Rights Reserved.
// Please feel free to use this code as an example.

import java.net.*;
import java.awt.*;

import marimba.io.*;
import marimba.gui.*;
import marimba.channel.*;

/**
 * The main channel class for the Headline channel. This class
 * simply tracks data as it becomes available and notifies the
 * headline and advertising widgets.
 *
 * @author	Arthur van Hoff
 */
public class Main extends ApplicationPlayerFrame {
    /**
     * New data is available. Ask the tuner to install it.
     */
    public void notifyAvailable(String dir) {
	context.installData("data.txt");
	context.installData("ads");
    }

    /**
     * New data has been installed. Tell the headline and advertizing
     * widgets to reload their data.
     */
    public void notifyInstall(String dir) {
	((HeadlineWidget)util.getWidget("headlines")).restart();
	((AdWidget)util.getWidget("ads")).restart();
	util.getPresentation().play("chirp.au");
    }
}
