// Copyright 1996, Marimba Inc. All Rights Reserved.
// Confidential and Proprietary Information of Marimba, Inc.
// @(#)Updates.java, 1.3, 01/04/97

package marimba.channel;

import java.io.*;
import java.util.*;

import marimba.io.*;
import marimba.util.*;

/** This class generates a list of pending updates, creates and
 * deletes that would be performed if all the changes for the
 * specified channel were installed right now.
 *
 * @author	Jonathan Payne
 * @version 1.3, 01/04/97
 */
public class Updates {
    Vector updates;
    Vector creates;
    Vector deletes;

    public Updates(Vector updates, Vector creates, Vector deletes) {
	this.updates = updates;
	this.creates = creates;
	this.deletes = deletes;
    }

    /** Returns the enumeration of all the deletions that are pending,
     * or null if there are none.
     */
    public Enumeration getDeletes() {
	return (deletes.size() > 0) ? deletes.elements() : null;
    }

    /** Returns the enumeration of all the creations that are pending,
     * or null if there are none.
     */
    public Enumeration getCreates() {
	return (creates.size() > 0) ? creates.elements() : null;
    }

    /** Returns the enumeration of all the updates that are pending,
     * or null if there are none.
     */
    public Enumeration getUpdates() {
	return (updates.size() > 0) ? updates.elements() : null;
    }
}
